<?php

namespace App\Knockout;

class AbstractData {

    protected $root;

    public function __construct()
    {
        $this->root = env('KNOCKOUT_API', 'https://api.knockout.chat');
    }

    private function encodeParameters($parameters = [])
    {
        $parameters = array_map(function($value, $key) {
            return urlencode($key) . '=' . urlencode($value);
        }, $parameters, array_keys($parameters));
        return '?' . implode('&', $parameters);
    }

    private function curl($path, $parameters = [])
    {
        $ch = curl_init(implode(null, [
            $this->root, $path, $this->encodeParameters($parameters)
        ]));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        return $ch;
    }

    public function httpGet($path, $parameters = [])
    {
        $ch = $this->curl($path, $parameters);
        $data = curl_exec($ch);
        curl_close($ch);
        return $data;
    }

    public function httpPost($path, $parameters = [], $properties = [])
    {

    }

}
